using System;
using System.Web;
using System.Configuration;
using System.Collections;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.IO;
using System.Text;
using System.Xml;
using System.Xml.XPath;
using OSGeo.MapGuide;
using System.Data.Sql;
using System.Data.SqlClient;

using java.io;
using ikvm.lang;
using com.lowagie.text;
using com.lowagie.text.pdf;
using com.lowagie.text.pdf.codec;

//using Jayrock.Json;
//using Jayrock.Json.Conversion;

[WebService(Namespace = "http://tempuri.org/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
[System.Web.Script.Services.ScriptService]
public class ScribbleMethodsMgr : System.Web.Services.WebService {
    public string _strConnString = null;
    public string _ApplicationPhysicalPath = null;
    public static string FL83_EF = "PROJCS[\"FL83-EF\",GEOGCS[\"LL83\",DATUM[\"NAD83\",SPHEROID[\"GRS1980\",6378137.000,298.25722210]],PRIMEM[\"Greenwich\",0],UNIT[\"Degree\",0.017453292519943295]],PROJECTION[\"Transverse_Mercator\"],PARAMETER[\"false_easting\",656166.667],PARAMETER[\"false_northing\",0.000],PARAMETER[\"scale_factor\",0.999941176471],PARAMETER[\"central_meridian\",-81.00000000000000],PARAMETER[\"latitude_of_origin\",24.33333333333333],UNIT[\"Foot_US\",0.30480060960122]]";
    public const string _schemaName = "Scribbles";
    public const string _className = "Scribble";
    public const string _groupName = "Scribbles";
    public const string _layerName = "_Scribble";
    public const string _IDpropertyName = "ID";
    public const string _TEXTpropertyName = "TEXT";
    public const string _GEOMETRYpropertyName = "GEO";
    public char[] SplitterCOMMA = new char[] { ',' };
    private MgSiteConnection _site = null;
    private StringBuilder _Session_StringBuilder = null;
    private string _session = null;
    private string _mapname = null;

    public ScribbleMethodsMgr() { }
    
    [WebMethod]
    public string Name() { return "ScribbleMethodsMgr"; }
    [WebMethod]
    public byte[] Point_GetBytes(string session, string mapname, string GEOMETRY)
    {
        if (this._site == null)
        {
            this.SetUp(session, mapname);
        }

        MgGeometryFactory geometryFactory = new MgGeometryFactory();
        MgAgfReaderWriter agfWriter = new MgAgfReaderWriter();

        string[] vertices = GEOMETRY.Split(SplitterCOMMA, StringSplitOptions.RemoveEmptyEntries);

        MgCoordinate coord = geometryFactory.CreateCoordinateXY(System.Convert.ToDouble(vertices[0]), System.Convert.ToDouble(vertices[1]));
        MgPoint point = geometryFactory.CreatePoint(coord);
        MgGeometricEntity epoint = point.Transform(this.GetTransform());
        MgByteReader byteReader = agfWriter.Write((MgPoint)epoint);
        byte[] destination_buff = null;
        using (System.IO.MemoryStream ms = new System.IO.MemoryStream())
        {
            byte[] buf = new byte[1024];
            int c = 0;
            do
            {
                c = byteReader.Read(buf, buf.Length);
                ms.Write(buf, 0, c);
            } while (c != 0);
            ms.Position = 0;
            destination_buff = ms.ToArray();
        }
        //StringBuilder Xport = new StringBuilder();
        //JsonConvert.Export(destination_buff, Xport);
        //return Xport.ToString();
        return destination_buff;

    }
    [WebMethod]
    public byte[] LineString_GetBytes(string session, string mapname, string GEOMETRY)
    {
        if (this._site == null)
        {
            this.SetUp(session, mapname);
        }

        MgGeometryFactory geometryFactory = new MgGeometryFactory();
        MgAgfReaderWriter agfWriter = new MgAgfReaderWriter();

        string[] vertices = GEOMETRY.Split(SplitterCOMMA, StringSplitOptions.RemoveEmptyEntries);
        int count = System.Convert.ToInt32(vertices[0]);

        MgCoordinateCollection coords = new MgCoordinateCollection();
        for (int i = 0; i < count; i++)
        {
            MgCoordinate coord = geometryFactory.CreateCoordinateXY(System.Convert.ToDouble(vertices[(i * 2) + 1]), System.Convert.ToDouble(vertices[(i * 2) + 2]));
            coords.Add(coord);
        }

        MgLineString lineString = geometryFactory.CreateLineString(coords);
        MgGeometricEntity elineString = lineString.Transform(this.GetTransform());
        MgByteReader byteReader = agfWriter.Write((MgLineString)elineString);
        byte[] destination_buff = null;
        using (System.IO.MemoryStream ms = new System.IO.MemoryStream())
        {
            byte[] buf = new byte[1024];
            int c = 0;
            do
            {
                c = byteReader.Read(buf, buf.Length);
                ms.Write(buf, 0, c);
            } while (c != 0);
            ms.Position = 0;
            destination_buff = ms.ToArray();
        }
        return destination_buff;
    }
    [WebMethod]
    public byte[] Polygon_GetBytes(string session, string mapname, string GEOMETRY)
    {
        if (this._site == null)
        {
            this.SetUp(session, mapname);
        }

        MgGeometryFactory geometryFactory = new MgGeometryFactory();
        MgAgfReaderWriter agfWriter = new MgAgfReaderWriter();

        string[] vertices = GEOMETRY.Split(SplitterCOMMA, StringSplitOptions.RemoveEmptyEntries);
        int count = System.Convert.ToInt32(vertices[0]);

        MgCoordinateCollection coords = new MgCoordinateCollection();
        for (int i = 0; i < count; i++)
        {
            MgCoordinate coord = geometryFactory.CreateCoordinateXY(System.Convert.ToDouble(vertices[(i * 2) + 1]), System.Convert.ToDouble(vertices[(i * 2) + 2]));
            coords.Add(coord);
        }
        MgLinearRing linearRing = geometryFactory.CreateLinearRing(coords);
        MgPolygon polygon = geometryFactory.CreatePolygon(linearRing, null);
        MgGeometricEntity epolygon = polygon.Transform(this.GetTransform());
        MgByteReader byteReader = agfWriter.Write((MgPolygon)epolygon);
        byte[] destination_buff = null;
        using (System.IO.MemoryStream ms = new System.IO.MemoryStream())
        {
            byte[] buf = new byte[1024];
            int c = 0;
            do
            {
                c = byteReader.Read(buf, buf.Length);
                ms.Write(buf, 0, c);
            } while (c != 0);
            ms.Position = 0;
            destination_buff = ms.ToArray();
        }
        return destination_buff;
    }
    [WebMethod]
    public byte[] Circle_GetBytes(string session, string mapname, string GEOMETRY)
    {
        if (this._site == null)
        {
            this.SetUp(session, mapname);
        }

        MgGeometryFactory geometryFactory = new MgGeometryFactory();
        MgAgfReaderWriter agfWriter = new MgAgfReaderWriter();

        string[] vertices = GEOMETRY.Split(SplitterCOMMA, StringSplitOptions.RemoveEmptyEntries);
        double radius = System.Convert.ToDouble(vertices[0]);
        MgCoordinate center_coord = geometryFactory.CreateCoordinateXY(System.Convert.ToDouble(vertices[1]), System.Convert.ToDouble(vertices[2]));

        MgCoordinate startCoordinate = geometryFactory.CreateCoordinateXY((center_coord.X + radius), center_coord.Y);
        MgCoordinate controlCoordinate = geometryFactory.CreateCoordinateXY(center_coord.X, (center_coord.Y + radius));
        MgCoordinate endCoordinate = geometryFactory.CreateCoordinateXY((center_coord.X - radius), center_coord.Y);
        MgArcSegment arcseg1 = geometryFactory.CreateArcSegment(startCoordinate, endCoordinate, controlCoordinate);

        controlCoordinate = geometryFactory.CreateCoordinateXY(center_coord.X, (center_coord.Y - radius));
        MgArcSegment arcseg2 = geometryFactory.CreateArcSegment(endCoordinate, startCoordinate, controlCoordinate);

        MgCurveSegmentCollection curveSegmentCollection = new MgCurveSegmentCollection();
        curveSegmentCollection.Add(arcseg1);
        curveSegmentCollection.Add(arcseg2);
        MgCurveRing exteriorCurveRing = geometryFactory.CreateCurveRing(curveSegmentCollection);

        // create curve polygon
        MgCurvePolygon curvePolygon = geometryFactory.CreateCurvePolygon(exteriorCurveRing, new MgCurveRingCollection());
        MgGeometricEntity ecurvePolygon = curvePolygon.Transform(this.GetTransform());
        MgByteReader byteReader = agfWriter.Write((MgCurvePolygon)ecurvePolygon);
        byte[] destination_buff = null;
        using (System.IO.MemoryStream ms = new System.IO.MemoryStream())
        {
            byte[] buf = new byte[1024];
            int c = 0;
            do
            {
                c = byteReader.Read(buf, buf.Length);
                ms.Write(buf, 0, c);
            } while (c != 0);
            ms.Position = 0;
            destination_buff = ms.ToArray();
        }
        return destination_buff;
    }
    [WebMethod]
    public void DeleteScribbleFeatures(string session, string mapname)
    {
        if (this._site == null)
        {
            this.SetUp(session, mapname);
        }
        MgFeatureService featureService = (MgFeatureService)_site.CreateService(MgServiceType.FeatureService);
        MgResourceIdentifier featureSourceId = new MgResourceIdentifier(_Session_StringBuilder.ToString() + _layerName + ".FeatureSource");
        MgFeatureCommandCollection commands = new MgFeatureCommandCollection();
        commands.Add(new MgDeleteFeatures(_className, _IDpropertyName + " > 0"));
        featureService.UpdateFeatures(featureSourceId, commands, false);
    }
    [WebMethod]
    public void DeleteScribbleSelectedFeatures(string session, string mapname, string input_selection)
    {
        if (this._site == null)
        {
            this.SetUp(session, mapname);
        }

        MgResourceService resourceService = _site.CreateService(MgServiceType.ResourceService) as MgResourceService;
        MgFeatureService featureService = _site.CreateService(MgServiceType.FeatureService) as MgFeatureService;
        MgResourceIdentifier featureSourceId = new MgResourceIdentifier(_Session_StringBuilder.ToString() + _layerName + ".FeatureSource");

        MgMap map = new MgMap();
        map.Open(resourceService, mapname);
        MgLayerBase scribbleLayer = map.GetLayers().GetItem(_layerName);
        string decodedXML = HttpUtility.UrlDecode(input_selection);
        MgSelection selection = new MgSelection(map);
        selection.FromXml(decodedXML);
        string generated_selection_keys = selection.GenerateFilter(scribbleLayer, (_schemaName + ":" + _className));
        MgFeatureCommandCollection commands = new MgFeatureCommandCollection();
        commands.Add(new MgDeleteFeatures(_className, generated_selection_keys));
        featureService.UpdateFeatures(featureSourceId, commands, false);
    }
    [WebMethod]
    public void MaterializeScribbleFeature(string session, string mapname, int geo_type, string text, string geometry)
    {
        if (this._site == null)
        {
            this.SetUp(session, mapname);
        }

        byte[] GEO = null;

        //int int_geo_type = System.Convert.ToInt32(geo_type);
        //switch (int_geo_type)
        switch (geo_type)
        {
            case ScribbleCommand.AddPoint:
                GEO = Point_GetBytes(session, mapname, geometry);
                break;
            case ScribbleCommand.AddCircle:
                GEO = Circle_GetBytes(session, mapname, geometry);
                break;
            case ScribbleCommand.AddLine:
            case ScribbleCommand.AddLineString:
                GEO = LineString_GetBytes(session, mapname, geometry);
                break;
            case ScribbleCommand.AddRectangle:
            case ScribbleCommand.AddPolygon:
                GEO = Polygon_GetBytes(session, mapname, geometry);         
                break;
            default:
                break;
        }
        MgPropertyCollection propertyValues = new MgPropertyCollection();
         // The Text
        propertyValues.Add(new MgStringProperty(_TEXTpropertyName, text));
        // The Geometry
        MgByteReader byteReader = new MgByteReader(GEO, GEO.Length, MgMimeType.Agf);
        propertyValues.Add(new MgGeometryProperty(_GEOMETRYpropertyName, byteReader));
        InsertScribbleFeature(propertyValues);
    }   
    [WebMethod]
    public void MaterializeScribble(string session, string mapname)
    {
        if (this._site == null)
        {
            this.SetUp(session, mapname);
        }

        MgResourceService resourceService = (MgResourceService)_site.CreateService(MgServiceType.ResourceService);
        MgFeatureService featureService = (MgFeatureService)_site.CreateService(MgServiceType.FeatureService);
        MgMap map = new MgMap();
        map.Open(resourceService, mapname);

        // Check for layer already on the map
        MgResourceIdentifier layerDefinitionId = new MgResourceIdentifier(_Session_StringBuilder.ToString() + _layerName + ".LayerDefinition");
        int index = map.GetLayers().IndexOf(layerDefinitionId.GetName());
        if (index >= 0)
        {
            return;
        }
        // 
        //#1 - Layer Group and Layer Name and Feature Source Name
        // Create the Layer Groups
        //
        MgLayerGroup markupGroup = null;
        MgLayerGroupCollection layerGroups = map.GetLayerGroups();
        if (layerGroups.Contains(_groupName))
        {
            markupGroup = layerGroups.GetItem(_groupName);
        }
        else
        {
            markupGroup = new MgLayerGroup(_groupName);
            markupGroup.SetVisible(true);
            markupGroup.SetLegendLabel(_groupName);
            markupGroup.SetDisplayInLegend(true);

            layerGroups.Add(markupGroup);
        }

        string Session_String = _Session_StringBuilder.ToString();
        StringBuilder sb = new StringBuilder(Session_String);
        // The LayerDefinition resource identifier
        sb.Append(_layerName);
        sb.Append(".");
        sb.Append(MgResourceType.LayerDefinition);
        MgResourceIdentifier markupLayerResId = null;
        try
        {
            markupLayerResId = new MgResourceIdentifier(sb.ToString());
        }
        catch (ManagedException mge) {/* bad name */ }
        sb.Length = 0;

        // The Feature Source resource identifier
        MgResourceIdentifier markupSdfResId = null;
        sb.Append(Session_String);
        sb.Append(_layerName);
        sb.Append(".");
        sb.Append(MgResourceType.FeatureSource);
        try
        {
            markupSdfResId = new MgResourceIdentifier(sb.ToString());
        }
        catch (ManagedException mge) {/* bad name */ }
        sb.Length = 0;
        //
        //#2 - Create the feature source
        // Create the Markup Feature Source (SDF)
        //
        MgFeatureSchema markupSchema = CreateScribbleSchema();
        MgFeatureSourceParams sdfParams = new MgCreateSdfParams("FL83-EF", FL83_EF, markupSchema);
        featureService.CreateFeatureSource(markupSdfResId, sdfParams);
        // 
        //#3 - Get the Scribble layer definition and modify
        //
        string final_path_to_xml = _ApplicationPhysicalPath + "scribblelayerdefinition.xml";
        XmlDocument doc = new XmlDocument();
        doc.PreserveWhitespace = true;
        doc.Load(final_path_to_xml);
        // FixUp the layer definition with the name of the session resource ....
        string _fixed_deflayer = null;
        _fixed_deflayer = string.Format(doc.OuterXml, markupSdfResId.ToString(), _schemaName, _className, _TEXTpropertyName, _GEOMETRYpropertyName);
        Encoding utf8 = Encoding.UTF8;
        byte[] layerDefinition = new byte[_fixed_deflayer.Length - 0];
        int byteCount = utf8.GetBytes(_fixed_deflayer, 0, _fixed_deflayer.Length - 0, layerDefinition, 0);
        MgByteSource byteSource = new MgByteSource(layerDefinition, layerDefinition.Length);
        byteSource.SetMimeType(MgMimeType.Xml);
        // Now set the resource in the map
        resourceService.SetResource(markupLayerResId, byteSource.GetReader(), null);
        // 
        //#4 - Add the layer and save the service
        //
        // Add the Markup Layer
        //
        MgLayer markupLayer = new MgLayer(markupLayerResId, resourceService);
        //markupLayer.SetName("_" + markupLayerResId.GetName());
        markupLayer.SetName(markupLayerResId.GetName());
        markupLayer.SetLegendLabel(markupLayerResId.GetName());

        markupLayer.SetDisplayInLegend(true);
        //markupLayer.SetDisplayInLegend(false);

        markupLayer.SetSelectable(true);
        markupLayer.SetGroup(markupGroup);
        map.GetLayers().Insert(0, markupLayer);

        map.Save(resourceService);
    }
    [WebMethod]
    public void DeMaterializeScribble(string session, string mapname)
    {
        if (this._site == null)
        {
            this.SetUp(session, mapname);
        }
        MgResourceService resourceService = (MgResourceService)_site.CreateService(MgServiceType.ResourceService);
        MgFeatureService featureService = (MgFeatureService)_site.CreateService(MgServiceType.FeatureService);

        MgResourceIdentifier featureSourceId = new MgResourceIdentifier(_Session_StringBuilder.ToString() + _layerName + ".FeatureSource");
        MgResourceIdentifier layerDefinitionId = new MgResourceIdentifier(_Session_StringBuilder.ToString() + _layerName + ".LayerDefinition");

        MgMap map = new MgMap();
        map.Open(resourceService, mapname);

        // remove layer from the map
        int index = map.GetLayers().IndexOf(layerDefinitionId.GetName());
        map.GetLayers().RemoveAt(index);
        index = map.GetLayerGroups().IndexOf(_groupName);
        map.GetLayerGroups().RemoveAt(index);

        // delete the layer defintion
        resourceService.DeleteResource(layerDefinitionId);
        // delete the feature source (SDF) defintion
        resourceService.DeleteResource(featureSourceId);
        // save it
        map.Save(resourceService);
    }
    [WebMethod]
    public string MaterializeScribbleSelectionXML(string session, string mapname, int scribble_feature)
    {
        if (this._site == null)
        {
            this.SetUp(session, mapname);
        }
        MgResourceService resourceService = (MgResourceService)_site.CreateService(MgServiceType.ResourceService);

        MgMap map = new MgMap();
        map.Open(resourceService, mapname);
        MgLayerBase markupLayer = map.GetLayers().GetItem(_layerName);

        MgSelectionBase selection = new MgSelection(map);
        selection.AddFeatureIdInt32(markupLayer, _schemaName + ":" + _className, scribble_feature);
        return selection.ToXml();
    }
    [WebMethod]
    public void UpdateScribbleText(string session, string mapname, string input_selection, string text)
    {
        if (this._site == null)
        {
            this.SetUp(session, mapname);
        }
        MgResourceService resourceService = _site.CreateService(MgServiceType.ResourceService) as MgResourceService;
        MgFeatureService featureService = (MgFeatureService)_site.CreateService(MgServiceType.FeatureService);
        MgResourceIdentifier featureSourceId = new MgResourceIdentifier(_Session_StringBuilder.ToString() + _layerName + ".FeatureSource");
        MgPropertyCollection propertyValues = new MgPropertyCollection();
        propertyValues.Add(new MgStringProperty(_TEXTpropertyName, text.Trim()));


        MgMap map = new MgMap();
        map.Open(resourceService, mapname);
        MgLayerBase scribbleLayer = map.GetLayers().GetItem(_layerName);
        string decodedXML = HttpUtility.UrlDecode(input_selection);
        MgSelection selection = new MgSelection(map);
        selection.FromXml(decodedXML);
        string generated_selection_keys = selection.GenerateFilter(scribbleLayer, (_schemaName + ":" + _className));
        MgFeatureCommandCollection commands = new MgFeatureCommandCollection();

        //commands.Add(new MgUpdateFeatures(_className, propertyValues, "ID = " + this.args["MARKUPFEATURE"]));
        commands.Add(new MgUpdateFeatures(_className, propertyValues, generated_selection_keys));
        featureService.UpdateFeatures(featureSourceId, commands, false);
    }  
    [WebMethod]
    public byte[] ExtractGeometryFromSelectedFeature(string session, string mapname, string input_selection)
    {
        if (this._site == null)
        {
            this.SetUp(session, mapname);
        }

        byte[] rtrnBytes = null;
        MgResourceService resourceService = _site.CreateService(MgServiceType.ResourceService) as MgResourceService;
        MgFeatureService featureService = _site.CreateService(MgServiceType.FeatureService) as MgFeatureService;
        MgResourceIdentifier featureSourceId = new MgResourceIdentifier(_Session_StringBuilder.ToString() + _layerName + ".FeatureSource");
        MgFeatureQueryOptions queryOptions = new MgFeatureQueryOptions();
        MgMap map = new MgMap();
        map.Open(resourceService, mapname);
        MgLayerBase scribbleLayer = map.GetLayers().GetItem(_layerName);
        MgSelection selection = new MgSelection(map);
        string decodedXML = HttpUtility.UrlDecode(input_selection);
        selection.FromXml(decodedXML);
        queryOptions.SetFilter(selection.GenerateFilter(scribbleLayer, (_schemaName + ":" + _className)));
        MgFeatureReader featureReader = featureService.SelectFeatures(featureSourceId, _className, queryOptions);
        MgAgfReaderWriter geometryReaderWriter = new MgAgfReaderWriter();

        while (featureReader.ReadNext())
        {
            MgByteReader byteReader = featureReader.GetGeometry(_GEOMETRYpropertyName);
            using (System.IO.MemoryStream ms = new System.IO.MemoryStream())
            {
                byte[] buf = new byte[1024];
                int c = 0;
                do
                {
                    c = byteReader.Read(buf, buf.Length);
                    ms.Write(buf, 0, c);
                } while (c != 0);
                ms.Position = 0;
                rtrnBytes = ms.ToArray();
            }
            MgGeometry geometry = geometryReaderWriter.Read(byteReader);
            break;
        }
        featureReader.Close();
        return rtrnBytes;

    }
    [WebMethod]
    public byte[] GetDBGeometry(string field, string table, string whereclause)
    {
        byte[] return_geometry = null;
        SqlConnection SQL_Conn = new SqlConnection();
        SQL_Conn.ConnectionString = _strConnString;
        SqlCommand Command_Bindata = new SqlCommand();
        Command_Bindata.CommandText = "SELECT [" + field + "] FROM " + table + " WHERE " + whereclause;
        try
        {
            SQL_Conn.Open();
            Command_Bindata.Connection = SQL_Conn;
            return_geometry = (byte[])Command_Bindata.ExecuteScalar();
            //JsonConvert.Export(all_records, all_records_sb);

        }
        catch (System.Exception) { }
        finally
        {
            if (SQL_Conn.State != System.Data.ConnectionState.Closed)
            {
                SQL_Conn.Close();
            }
        }
        return return_geometry;
    }
    [WebMethod]
    public int PutDBGeometry(string field, string table, string whereclause, byte[] val)
    {
        int return_count = 0;
        SqlConnection SQL_Conn = new SqlConnection();
        SQL_Conn.ConnectionString = _strConnString;
        SqlCommand Command_Bindata = new SqlCommand();
        Command_Bindata.CommandText = "UPDATE " + table + " SET [" + field + "] = @bindata WHERE " + whereclause;
        Command_Bindata.Parameters.Add("@bindata", System.Data.SqlDbType.Image);
        Command_Bindata.Parameters["@bindata"].Value = val;
        try
        {
            SQL_Conn.Open();
            Command_Bindata.Connection = SQL_Conn;
            return_count = Command_Bindata.ExecuteNonQuery();
            //JsonConvert.Export(all_records, all_records_sb);
        }
        catch (System.Exception) { }
        finally
        {
            if (SQL_Conn.State != System.Data.ConnectionState.Closed)
            {
                SQL_Conn.Close();
            }
        }
        return return_count;
    }
    [WebMethod]
    public byte[] MaterializeMapImagePage(string session, string mapname, int width, int height, string imageflavor)
    {
        if (this._site == null)
        {
            this.SetUp(session, mapname);
        }
        byte[] forImg = null;

        MgResourceService resourceService = (MgResourceService)_site.CreateService(MgServiceType.ResourceService);
        MgRenderingService renderingService = (MgRenderingService)_site.CreateService(MgServiceType.RenderingService);
        MgMap map = new MgMap();
        map.Open(resourceService, mapname);

        MgSelection selection = null;
        MgColor color = new MgColor(255, 255, 255);
        double mapCenterX = map.GetViewCenter().Coordinate.X;
        double mapCenterY = map.GetViewCenter().Coordinate.Y;
        double mapScale = map.GetViewScale();
        MgGeometryFactory geometryFactory = new MgGeometryFactory();
        MgCoordinate mapCenterCoordinate = geometryFactory.CreateCoordinateXY(mapCenterX, mapCenterY);
        MgByteReader byteReader = renderingService.RenderMap(map, selection, mapCenterCoordinate, mapScale, width, height, color, imageflavor.ToUpper());

        MemoryStream memBuf = new MemoryStream();
        byte[] byteBuffer = new byte[1024];
        int numBytes = byteReader.Read(byteBuffer, 1024);
        while (numBytes > 0)
        {
            memBuf.Write(byteBuffer, 0, numBytes);
            numBytes = byteReader.Read(byteBuffer, 1024);
        }
        forImg = memBuf.ToArray();

        return forImg;
    }
    [WebMethod]
    public byte[] MaterializeMapPDFPage(string session, string mapname, int width, int height, string imageflavor)
    {
        if (this._site == null)
        {
            this.SetUp(session, mapname);
        }
        Document document = null;
        ByteArrayOutputStream baos = null;
        PdfWriter pdfwriter = null;

        byte[] forPdf = MaterializeMapImagePage(session, mapname, width, height, imageflavor);
        try
        {
            com.lowagie.text.Image img = com.lowagie.text.Image.getInstance(forPdf);

            // Ok .. we have the image. Now we must set the page size. In order to set the first page
            // correctly we MUST determine the size and orientation BEFORE we open. We wish to have 
            // the NEARLY correct standard paper size then scale the image accordingly. 
            // Hopefully we will always have the correct orientation.
            // In addition scaling is based on this size.

            float x = img.getScaledWidth();
            float y = img.getScaledHeight();
            float xDPI = img.getDpiX();
            float yDPI = img.getDpiY();
            float xINCHS = (x / xDPI);
            float yINCHS = (y / yDPI);
            // 
            // If we have an easy to detect error with the image we will say so
            //
            if ((xINCHS <= 1.0) || (yINCHS <= 1.0))
            {
                // force the page size
                xINCHS = 8f;
                yINCHS = 11f;
            }
            else { }
            // 
            // Now we set the page size and orientation
            //                
            Rectangle MyPageSize = null;
            if (xINCHS >= 23.39)
            {
                if (x > y)
                {
                    MyPageSize = new Rectangle(PageSize.A0.rotate());
                }
                else
                {
                    MyPageSize = new Rectangle(PageSize.A0);
                }
            }
            else if (xINCHS >= 16.54)
            {
                if (x > y)
                {
                    MyPageSize = new Rectangle(PageSize.A1.rotate());
                }
                else
                {
                    MyPageSize = new Rectangle(PageSize.A1);
                }
            }
            else if (xINCHS >= 11.69)
            {
                if (x > y)
                {
                    MyPageSize = new Rectangle(PageSize.A2.rotate());
                }
                else
                {
                    MyPageSize = new Rectangle(PageSize.A2);
                }
            }
            else if (xINCHS > 8.27)
            {
                if (x > y)
                {
                    MyPageSize = new Rectangle(PageSize.A3.rotate());
                }
                else
                {
                    MyPageSize = new Rectangle(PageSize.A3);
                }
            }
            else
            {
                if (x > y)
                {
                    MyPageSize = new Rectangle(PageSize.A4.rotate());
                }
                else
                {
                    MyPageSize = new Rectangle(PageSize.A4);
                }
            }

            // step 1: creation of a document-object
            document = new Document(MyPageSize);
            document.setMargins(25f, 25f, 25f, 25f);
            // step 2:
            // we create a writer that listens to the document and directs a PDF-stream to a file
            baos = new ByteArrayOutputStream();
            pdfwriter = PdfWriter.getInstance(document, baos);
             // step 3: we open the document
            document.open();
            document.setPageSize(MyPageSize);
            document.newPage();

            // step 4: add the content
            img.scaleToFit(MyPageSize.getWidth(), MyPageSize.getHeight());
            img.setAbsolutePosition(0, 0);
            document.add(img);

        }
        catch (System.Exception ex)
        {
            StringBuilder sb = new StringBuilder();
            sb.Append(" ***** Error with Map Image --> ");
            sb.Append("Session: " + session + "    Map: " +  mapname);
            sb.Append(" ***** Contact Application Maintenance Personnel.");
            document.add(new Paragraph(sb.ToString()));
        }
       
        // step 5: we close the document
        if (document != null)
            document.close();

        forPdf = baos.toByteArray();
       
        return forPdf;
    }
    [WebMethod]
    public string MaterializeSelectedFeaturesProperties(string session, string mapname, string currentselectionXML)
    {
        if (this._site == null)
        {
            this.SetUp(session, mapname);
        }
        StringBuilder output_string = null;
        MgResourceService resourceService = _site.CreateService(MgServiceType.ResourceService) as MgResourceService;
        MgFeatureService featureService = _site.CreateService(MgServiceType.FeatureService) as MgFeatureService;
        MgFeatureQueryOptions queryOptions = new MgFeatureQueryOptions();
        MgMap map = new MgMap();

        map.Open(resourceService, mapname);
        MgSelection selection = new MgSelection(map, currentselectionXML);
        MgReadOnlyLayerCollection layers = selection.GetLayers();
        Int32 layerCount = layers.GetCount();
        if (layerCount > 0)
        {
            output_string = new StringBuilder();
            for (int i = 0; i < layers.GetCount(); i++)
            {
                MgLayerBase layer = layers.GetItem(i);
                Hashtable htProps = MaterializeLayerPropertiesDefinition(session, mapname, layer.Name);
                // Create a filter containing the IDs of the selected
                // features on this layer
                string layerClassName = layer.GetFeatureClassName();
                string selectionString = selection.GenerateFilter(layer, layerClassName);
                // Get the feature resource for the selected layer
                string layerFeatureID = layer.GetFeatureSourceId();
                MgResourceIdentifier layerFeatureResource = new MgResourceIdentifier(layerFeatureID);
                // Apply the filter to the feature resource for the selected layer.
                // This returns an MgFeatureReader of all the selected features.
                queryOptions.SetFilter(selectionString);
                MgFeatureReader featureReader = featureService.SelectFeatures(layerFeatureResource, layerClassName, queryOptions);
                //MgAgfReaderWriter geometryReaderWriter = new MgAgfReaderWriter();
                StringBuilder sb = new StringBuilder();

                // Output the layer it came from ...
                output_string.Append("<br /><h1>" + layer.Name + "</h1>");

                // Output the properties header (field name) 
                sb.Append("<table>");
                foreach (DictionaryEntry de in htProps)
                {
                    sb.Append(@"<th bgcolor=""lightgrey"">");
                    string v = (string)de.Key;
                    sb.Append(v);
                    sb.Append("</th>");
                }
                output_string.Append(sb.ToString());

                // Output the properties values (field value) 
                while (featureReader.ReadNext())
                {
                    sb.Length = 0;
                    sb.Append("<tr>");
                    foreach (DictionaryEntry de in htProps)
                    {
                        sb.Append("<td>");
                        string v = GetFeaturePropertyValue(featureReader, (string)de.Key);
                        sb.Append(v);
                        sb.Append("</td>");
                    }
                    sb.Append("</tr>");
                    output_string.Append(sb.ToString());
                }
                featureReader.Close();
                output_string.Append("</table>");
            }
        }
        return output_string.ToString();
    }
    [WebMethod]
    public Hashtable MaterializeLayerPropertiesDefinition(string session, string mapname, string layername)
    {
        if (this._site == null)
        {
            this.SetUp(session, mapname);
        }
        Hashtable properties = new Hashtable();
        MgResourceService resourceService = (MgResourceService)this._site.CreateService(MgServiceType.ResourceService);
        MgMap map = new MgMap();
        map.Open(resourceService, mapname);
        MgLayer layer = (MgLayer)map.GetLayers().GetItem(layername);

        MgFeatureService featureService = (MgFeatureService)this._site.CreateService(MgServiceType.FeatureService);
        MgResourceIdentifier resId = new MgResourceIdentifier(layer.GetFeatureSourceId());
        String[] schemaClass = layer.GetFeatureClassName().Split(new Char[] { ':' });

        MgClassDefinition classDef = featureService.GetClassDefinition(resId, schemaClass[0], schemaClass[1]);

        for (int i = 0; i < classDef.GetProperties().GetCount(); i++)
        {
            MgPropertyDefinition propertyDef = classDef.GetProperties().GetItem(i);

            if (propertyDef.GetPropertyType() == MgFeaturePropertyType.DataProperty)
            {
                MgDataPropertyDefinition propertyDataDef = (MgDataPropertyDefinition)propertyDef;
                int dataType = propertyDataDef.GetDataType();
                if (this.IsValidDataType(dataType))
                {
                    properties.Add(propertyDataDef.GetName(), dataType);
                }
            }
        }
        return properties;
    }
    
    private void SetUp(string session, string mapname)
    {
        this._mapname = mapname;
        this._session = session;
        this._site = new MgSiteConnection();
        this._site.Open(new MgUserInformation(session));
        this._Session_StringBuilder = new StringBuilder();
        this._Session_StringBuilder.Append("Session:");
        this._Session_StringBuilder.Append(session);
        this._Session_StringBuilder.Append("//");
        this._ApplicationPhysicalPath = this.Context.Request.ServerVariables["APPL_PHYSICAL_PATH"];
    }   
    private MgFeatureSchema CreateScribbleSchema()
    {
        MgFeatureSchema markupSchema = new MgFeatureSchema();
        markupSchema.SetName(_schemaName);
        markupSchema.GetClasses().Add(CreateScribbleClass());

        return markupSchema;
    }
    private MgClassDefinition CreateScribbleClass()
    {
        MgClassDefinition markupClass = new MgClassDefinition();
        markupClass.SetName(_className);
        MgPropertyDefinitionCollection properties = markupClass.GetProperties();
        //ID
        MgDataPropertyDefinition idProperty = new MgDataPropertyDefinition(_IDpropertyName);
        idProperty.SetDataType(MgPropertyType.Int32);
        idProperty.SetReadOnly(true);
        idProperty.SetNullable(false);
        idProperty.SetAutoGeneration(true);
        properties.Add(idProperty);
        // Text
        MgDataPropertyDefinition textProperty = new MgDataPropertyDefinition(_TEXTpropertyName);
        textProperty.SetDataType(MgPropertyType.String);
        textProperty.SetLength(64);
        properties.Add(textProperty);
        //Geometry
        MgGeometricPropertyDefinition geometryProperty = new MgGeometricPropertyDefinition(_GEOMETRYpropertyName);
        geometryProperty.SetGeometryTypes(MgFeatureGeometricType.Point | MgFeatureGeometricType.Curve | MgFeatureGeometricType.Surface);
        geometryProperty.SetHasElevation(false);
        geometryProperty.SetHasMeasure(false);
        geometryProperty.SetReadOnly(false);
        geometryProperty.SetSpatialContextAssociation("FL83-EF");
        properties.Add(geometryProperty);

        // Set identity and geometry
        markupClass.GetIdentityProperties().Add(idProperty);
        markupClass.SetDefaultGeometryPropertyName(_GEOMETRYpropertyName);

        return markupClass;
    }
    private MgTransform GetTransform()
    {
        MgResourceService resourceService = (MgResourceService)_site.CreateService(MgServiceType.ResourceService);
        MgCoordinateSystemFactory coordSysFactory = new MgCoordinateSystemFactory();

        MgMap map = new MgMap();
        map.Open(resourceService, this._mapname);

        MgCoordinateSystem source = coordSysFactory.Create(map.GetMapSRS());
        MgCoordinateSystem target = coordSysFactory.Create(FL83_EF);

        return new MgCoordinateSystemTransform(source, target);
    }
    private void InsertScribbleFeature(MgPropertyCollection propertyValues)
    {
        MgFeatureService featureService = (MgFeatureService)_site.CreateService(MgServiceType.FeatureService);
        MgResourceIdentifier featureSourceId = new MgResourceIdentifier(_Session_StringBuilder.ToString() + _layerName + ".FeatureSource");
        MgFeatureCommandCollection commands = new MgFeatureCommandCollection();
        commands.Add(new MgInsertFeatures(_className, propertyValues));
        featureService.UpdateFeatures(featureSourceId, commands, false);
    }
    private bool IsValidDataType(int type)
    {
        bool valid = true;
        switch (type)
        {
            case MgPropertyType.Blob:
            case MgPropertyType.Clob:
            case MgPropertyType.Byte:
            case MgPropertyType.Feature:
            case MgPropertyType.Geometry:
            case MgPropertyType.Null:
                valid = false;
                break;
        }
        return valid;
    }
    private string GetFeaturePropertyValue(MgReader featureReader, string propName)
    {
        string value = "";
        int propertyType = featureReader.GetPropertyType(propName);
        switch (propertyType)
        {
            case MgPropertyType.Boolean:
                value = featureReader.GetBoolean(propName).ToString();
                break;
            case MgPropertyType.Byte:
                value = featureReader.GetByte(propName).ToString();
                break;
            case MgPropertyType.Single:
                value = featureReader.GetSingle(propName).ToString();
                break;
            case MgPropertyType.Double:
                value = featureReader.GetDouble(propName).ToString();
                break;
            case MgPropertyType.Int16:
                value = featureReader.GetInt16(propName).ToString();
                break;
            case MgPropertyType.Int32:
                value = featureReader.GetInt32(propName).ToString();
                break;
            case MgPropertyType.Int64:
                value = featureReader.GetInt64(propName).ToString();
                break;
            case MgPropertyType.String:
                value = featureReader.GetString(propName);
                break;
            case MgPropertyType.DateTime:
            case MgPropertyType.Null:
            case MgPropertyType.Blob:
            case MgPropertyType.Clob:
            case MgPropertyType.Feature:
            case MgPropertyType.Geometry:
            case MgPropertyType.Raster:
                value = "[unsupported data type]";
                break;
        }
        return value;
    }

}

